package cn.estsh.i3plus.ext.mes.pcn.pojo.model;

import cn.estsh.i3plus.pojo.mes.bean.MesLabelTemplate;
import cn.estsh.i3plus.pojo.mes.bean.MesPackingDefine;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description : 条码补打Model
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/13 15:48
 * @Modify:
 **/
@Data
public class MesProduceSnPrintModel {

    @ApiParam("工厂代码")
    private String organizeCode;

    @ApiParam("物料号")
    private String partNo;

    @ApiParam("物料名称")
    private String partName;

    @ApiParam("条码")
    private String productSn;

    @ApiParam("打印数量")
    private Integer printQty;

    @ApiParam("标包数量")
    private Double qty;

    @ApiParam("打印模板")
    private String printTemplate;

    @ApiParam("条码规则")
    private String snRule;

    @ApiParam(name = "包装规则代码")
    private String packCode;

    @ApiParam(name = "用户名")
    private String userName;

    @ApiParam(value = "打印机")
    private String printer;

    @ApiParam(name = "包装定义维护")
    List<MesPackingDefine> mesPackingDefineList;

    @ApiParam(name = "打印模板信息")
    private MesLabelTemplate mesLabelTemplate;

    @ApiParam(name = "产品条码信息")
    private List<MesProduceSnPrintDataModel> mesProduceSnPrintDataModelList = new ArrayList<>();

    public Double getQty() {
        return qty == null || qty <= 0d ? 1d : qty;
    }
}
